# ASU CSE365: Introduction to Cybersecurity

## Descriptions

- Offered by: Arizona State University
- Prerequisites: None
- Programming Languages: C, Python, x86 assembly
- Difficulty: 🌟🌟🌟🌟
- Class Hour: Varying from person to person

An introductory course on web security at Arizona State University, the course contains several modules, mainly including:

- Program Misuse: Linux commandline, privilege escalation
- Web fundamentals: http, server, intercept
- Assembly: registers, memory, control flow
- Cryptography: Symmetric/Asymmetric encryption, hashing, trust
- Web security: Command/HTML/SQL/Stack injection

The course is mainly based on challenges, supplemented by lectures and reading materials. The challenges are developed in the form of CTF, and the difficulty increases in order.

For hackers with weak foundations, getting stuck is a normal phenomenon. If you encounter difficulties in solving the problem, you can seek help from the Discord Server given in the Chat column on the homepage.

## Course Resources

- Course Website: <https://dojo.pwn.college/cse365/>
- Recordings: See course website
- Textbooks: None
- Assignments: 7 modules (167 challenges)

## Personal Resources

- Lectures on YouTube: <https://youtube.com/pwncollege>
- Live Broadcasts on Twitch: <https://twitch.tv/pwncollege>
- Chat on Discord: <https://pwn.college/discord>
- Open Source on GitHub: <https://github.com/pwncollege>
- Contact us via Email: <pwn-college@asu.edu>

In addition, due to an important factor in evaluating ASU students' course grades, the course does not encourage uploading problem-solving ideas, except for the first two challenges of each module.
