# MIT 6.031: Software Construction

## Descriptions

- Offered by: MIT
- Prerequisites: better if you are already proficient in a programming language
- Programming Languages: Java
- Difficulty: 🌟🌟🌟🌟
- Class Hour: 100 hours

The goal of this course is for you to learn how to write high quality code, and what is meant by high quality is to meet the following three targets:

> Safe from bugs. Correctness (correct behavior right now) and defensiveness (correct behavior in the future) are required in any software we build.
>
> Easy to understand. The code has to communicate to future programmers who need to understand it and make changes in it (fixing bugs or adding new features). That future programmer might be you, months or years from now. You’ll be surprised how much you forget if you don’t write it down, and how much it helps your own future self to have a good design.
>
> Ready for change. Software always changes. Some designs make it easy to make changes; others require throwing away and rewriting a lot of code.

To achieve this, the instructors write a book explaining many of the core principles of software construction and valuable lessons learned from the past. The book covers many practical topics such as how to write comments and specifications, how to design abstract data structures, and many parallel programming caveats. You will explore all of these ideas in the programming assignments.

In the 2016 spring, the course open-sourced all of its programming assignments, and the textbook can be found on the latest website (see links below).

## Course Resources

- Course Website: [2021spring](http://web.mit.edu/6.031/www/sp21/), [2016spring](https://ocw.mit.edu/courses/electrical-engineering-and-computer-science/6-005-software-construction-spring-2016/)
- Recordings: None
- Assignments: 4 Problem Sets + 1 Project

## Personal Resources

All the resources and assignments used by @PKUFlyingPig in this course are maintained in [PKUFlyingPig/ MIT6.031-Software-Engineering - GitHub](https://github.com/PKUFlyingPig/MIT6.031-software-construction)

@pengzhangzhi completed the assignments and took some notes, maintained at [pengzhangzhi/self-taught-CS/Software Construction - Github](https://github.com/pengzhangzhi/self-taught-CS/tree/main/Software%20Construction)
